/* i-properties-provider.c generated by valac 0.18.0.9-06717, the Vala compiler
 * generated from i-properties-provider.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <libcommon.h>
#include <float.h>
#include <math.h>
#include <osinfo/osinfo.h>


#define BOXES_TYPE_PROPERTY (boxes_property_get_type ())
#define BOXES_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_PROPERTY, BoxesProperty))
#define BOXES_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_PROPERTY, BoxesPropertyClass))
#define BOXES_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_PROPERTY))
#define BOXES_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_PROPERTY))
#define BOXES_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_PROPERTY, BoxesPropertyClass))

typedef struct _BoxesProperty BoxesProperty;
typedef struct _BoxesPropertyClass BoxesPropertyClass;
typedef struct _BoxesPropertyPrivate BoxesPropertyPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define BOXES_TYPE_IPROPERTIES_PROVIDER (boxes_iproperties_provider_get_type ())
#define BOXES_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProvider))
#define BOXES_IS_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER))
#define BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProviderIface))

typedef struct _BoxesIPropertiesProvider BoxesIPropertiesProvider;
typedef struct _BoxesIPropertiesProviderIface BoxesIPropertiesProviderIface;

#define BOXES_TYPE_PROPERTIES_PAGE (boxes_properties_page_get_type ())

#define BOXES_TYPE_EDITABLE_ENTRY (boxes_editable_entry_get_type ())
#define BOXES_EDITABLE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntry))
#define BOXES_EDITABLE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntryClass))
#define BOXES_IS_EDITABLE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_EDITABLE_ENTRY))
#define BOXES_IS_EDITABLE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_EDITABLE_ENTRY))
#define BOXES_EDITABLE_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntryClass))

typedef struct _BoxesEditableEntry BoxesEditableEntry;
typedef struct _BoxesEditableEntryClass BoxesEditableEntryClass;
typedef struct _Block11Data Block11Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block12Data Block12Data;

struct _BoxesProperty {
	GObject parent_instance;
	BoxesPropertyPrivate * priv;
};

struct _BoxesPropertyClass {
	GObjectClass parent_class;
};

struct _BoxesPropertyPrivate {
	gchar* _description;
	GtkWidget* _widget;
	gboolean _reboot_required;
	guint _defer_interval;
	guint deferred_change_id;
	GSourceFunc _deferred_change;
	gpointer _deferred_change_target;
	GDestroyNotify _deferred_change_target_destroy_notify;
};

typedef void (*PropertyStringChanged) (BoxesProperty* property, const gchar* value, void* user_data, GError** error);
typedef void (*PropertySizeChanged) (BoxesProperty* property, guint64 value, void* user_data, GError** error);
typedef enum  {
	BOXES_PROPERTIES_PAGE_LOGIN,
	BOXES_PROPERTIES_PAGE_SYSTEM,
	BOXES_PROPERTIES_PAGE_DISPLAY,
	BOXES_PROPERTIES_PAGE_DEVICES,
	BOXES_PROPERTIES_PAGE_LAST
} BoxesPropertiesPage;

struct _BoxesIPropertiesProviderIface {
	GTypeInterface parent_iface;
	GList* (*get_properties) (BoxesIPropertiesProvider* self, BoxesPropertiesPage page);
};

struct _Block11Data {
	int _ref_count_;
	BoxesIPropertiesProvider * self;
	BoxesEditableEntry* entry;
	BoxesProperty* property;
	PropertyStringChanged changed;
	gpointer changed_target;
};

struct _Block12Data {
	int _ref_count_;
	BoxesIPropertiesProvider * self;
	GtkHScale* scale;
	BoxesProperty* property;
	PropertySizeChanged changed;
	gpointer changed_target;
};


static gpointer boxes_property_parent_class = NULL;

GType boxes_property_get_type (void) G_GNUC_CONST;
#define BOXES_PROPERTY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_PROPERTY, BoxesPropertyPrivate))
enum  {
	BOXES_PROPERTY_DUMMY_PROPERTY,
	BOXES_PROPERTY_DESCRIPTION,
	BOXES_PROPERTY_WIDGET,
	BOXES_PROPERTY_REBOOT_REQUIRED,
	BOXES_PROPERTY_DEFER_INTERVAL
};
BoxesProperty* boxes_property_new (const gchar* description, GtkWidget* widget);
BoxesProperty* boxes_property_construct (GType object_type, const gchar* description, GtkWidget* widget);
void boxes_property_flush (BoxesProperty* self);
GSourceFunc boxes_property_get_deferred_change (BoxesProperty* self, gpointer* result_target);
void boxes_property_set_deferred_change (BoxesProperty* self, GSourceFunc value, gpointer value_target, GDestroyNotify value_target_destroy_notify);
const gchar* boxes_property_get_description (BoxesProperty* self);
void boxes_property_set_description (BoxesProperty* self, const gchar* value);
GtkWidget* boxes_property_get_widget (BoxesProperty* self);
void boxes_property_set_widget (BoxesProperty* self, GtkWidget* value);
gboolean boxes_property_get_reboot_required (BoxesProperty* self);
void boxes_property_set_reboot_required (BoxesProperty* self, gboolean value);
guint boxes_property_get_defer_interval (BoxesProperty* self);
void boxes_property_set_defer_interval (BoxesProperty* self, guint value);
static gboolean _boxes_property_deferred_change___lambda12_ (BoxesProperty* self);
static gboolean __boxes_property_deferred_change___lambda12__gsource_func (gpointer self);
static void boxes_property_finalize (GObject* obj);
static void _vala_boxes_property_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_boxes_property_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType boxes_properties_page_get_type (void) G_GNUC_CONST;
GType boxes_iproperties_provider_get_type (void) G_GNUC_CONST;
GList* boxes_iproperties_provider_get_properties (BoxesIPropertiesProvider* self, BoxesPropertiesPage page);
BoxesProperty* boxes_iproperties_provider_add_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, GtkWidget* widget);
BoxesProperty* boxes_iproperties_provider_add_string_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, const gchar* value, PropertyStringChanged changed, void* changed_target);
GType boxes_editable_entry_get_type (void) G_GNUC_CONST;
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
BoxesEditableEntry* boxes_editable_entry_new (void);
BoxesEditableEntry* boxes_editable_entry_construct (GType object_type);
void boxes_editable_entry_set_text (BoxesEditableEntry* self, const gchar* value);
void boxes_editable_entry_set_selectable (BoxesEditableEntry* self, gboolean value);
void boxes_editable_entry_set_editable (BoxesEditableEntry* self, gboolean value);
static void __lambda19_ (Block11Data* _data11_);
const gchar* boxes_editable_entry_get_text (BoxesEditableEntry* self);
void boxes_editable_entry_start_editing (BoxesEditableEntry* self);
static void ___lambda19__boxes_editable_entry_editing_done (BoxesEditableEntry* _sender, gpointer self);
BoxesProperty* boxes_iproperties_provider_add_size_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, guint64 size, guint64 min, guint64 max, guint64 step, PropertySizeChanged changed, void* changed_target);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static gchar* __lambda20_ (BoxesIPropertiesProvider* self, GtkScale* scale, gdouble value);
static gchar* ___lambda20__gtk_scale_format_value (GtkScale* _sender, gdouble value, gpointer self);
static void ___lambda21_ (Block12Data* _data12_);
static void ____lambda21__gtk_range_value_changed (GtkRange* _sender, gpointer self);


BoxesProperty* boxes_property_construct (GType object_type, const gchar* description, GtkWidget* widget) {
	BoxesProperty * self = NULL;
	const gchar* _tmp0_;
	GtkWidget* _tmp1_;
#line 36 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 36 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 37 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = description;
#line 37 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = widget;
#line 37 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = (BoxesProperty*) g_object_new (object_type, "description", _tmp0_, "widget", _tmp1_, NULL);
#line 36 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return self;
#line 179 "i-properties-provider.c"
}


BoxesProperty* boxes_property_new (const gchar* description, GtkWidget* widget) {
#line 36 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return boxes_property_construct (BOXES_TYPE_PROPERTY, description, widget);
#line 186 "i-properties-provider.c"
}


void boxes_property_flush (BoxesProperty* self) {
	GSourceFunc _tmp0_;
	void* _tmp0__target;
	GSourceFunc _tmp1_;
	void* _tmp1__target;
	GSourceFunc _tmp2_;
	void* _tmp2__target;
	GSourceFunc _tmp3_;
	void* _tmp3__target;
#line 40 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 41 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = boxes_property_get_deferred_change (self, &_tmp0__target);
#line 41 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = _tmp0_;
#line 41 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1__target = _tmp0__target;
#line 41 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp1_ == NULL) {
#line 42 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 211 "i-properties-provider.c"
	}
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = boxes_property_get_deferred_change (self, &_tmp2__target);
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = _tmp2_;
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3__target = _tmp2__target;
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ (_tmp3__target);
#line 46 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_property_set_deferred_change (self, NULL, NULL, NULL);
#line 223 "i-properties-provider.c"
}


const gchar* boxes_property_get_description (BoxesProperty* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_description;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 238 "i-properties-provider.c"
}


void boxes_property_set_description (BoxesProperty* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (self->priv->_description);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_description = _tmp1_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "description");
#line 257 "i-properties-provider.c"
}


GtkWidget* boxes_property_get_widget (BoxesProperty* self) {
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_widget;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 272 "i-properties-provider.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return self ? g_object_ref (self) : NULL;
#line 279 "i-properties-provider.c"
}


void boxes_property_set_widget (BoxesProperty* self, GtkWidget* value) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_object_unref0 (self->priv->_widget);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_widget = _tmp1_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "widget");
#line 298 "i-properties-provider.c"
}


gboolean boxes_property_get_reboot_required (BoxesProperty* self) {
	gboolean result;
	gboolean _tmp0_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_reboot_required;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 313 "i-properties-provider.c"
}


void boxes_property_set_reboot_required (BoxesProperty* self, gboolean value) {
	gboolean _tmp0_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_reboot_required = _tmp0_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "reboot-required");
#line 327 "i-properties-provider.c"
}


guint boxes_property_get_defer_interval (BoxesProperty* self) {
	guint result;
	guint _tmp0_;
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_defer_interval;
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 342 "i-properties-provider.c"
}


void boxes_property_set_defer_interval (BoxesProperty* self, guint value) {
	guint _tmp0_;
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_defer_interval = _tmp0_;
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "defer-interval");
#line 356 "i-properties-provider.c"
}


GSourceFunc boxes_property_get_deferred_change (BoxesProperty* self, gpointer* result_target) {
	GSourceFunc result;
	GSourceFunc _tmp0_;
	void* _tmp0__target;
	GSourceFunc _tmp1_;
	void* _tmp1__target;
#line 14 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_deferred_change;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0__target = self->priv->_deferred_change_target;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = _tmp0_;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1__target = _tmp0__target;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	*result_target = _tmp1__target;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp1_;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 382 "i-properties-provider.c"
}


static gboolean _boxes_property_deferred_change___lambda12_ (BoxesProperty* self) {
	gboolean result = FALSE;
#line 29 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_property_flush (self);
#line 31 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = FALSE;
#line 31 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 394 "i-properties-provider.c"
}


static gboolean __boxes_property_deferred_change___lambda12__gsource_func (gpointer self) {
	gboolean result;
	result = _boxes_property_deferred_change___lambda12_ (self);
#line 28 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 403 "i-properties-provider.c"
}


void boxes_property_set_deferred_change (BoxesProperty* self, GSourceFunc value, gpointer value_target, GDestroyNotify value_target_destroy_notify) {
	guint _tmp0_;
	GSourceFunc _tmp2_;
	void* _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	GSourceFunc _tmp3_;
	void* _tmp3__target;
	guint _tmp4_;
	guint _tmp5_ = 0U;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 19 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->deferred_change_id;
#line 19 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 422 "i-properties-provider.c"
		guint _tmp1_;
#line 20 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp1_ = self->priv->deferred_change_id;
#line 20 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_source_remove (_tmp1_);
#line 21 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		self->priv->deferred_change_id = (guint) 0;
#line 430 "i-properties-provider.c"
	}
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = value;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2__target = value_target;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2__target_destroy_notify = value_target_destroy_notify;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value_target_destroy_notify = NULL;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	(self->priv->_deferred_change_target_destroy_notify == NULL) ? NULL : (self->priv->_deferred_change_target_destroy_notify (self->priv->_deferred_change_target), NULL);
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change = NULL;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target = NULL;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target_destroy_notify = NULL;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change = _tmp2_;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target = _tmp2__target;
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target_destroy_notify = _tmp2__target_destroy_notify;
#line 25 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = self->priv->_deferred_change;
#line 25 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3__target = self->priv->_deferred_change_target;
#line 25 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp3_ == NULL) {
#line 26 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
#line 26 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		value = NULL;
#line 26 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		value_target = NULL;
#line 26 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		value_target_destroy_notify = NULL;
#line 26 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 470 "i-properties-provider.c"
	}
#line 28 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = self->priv->_defer_interval;
#line 28 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp5_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, _tmp4_, __boxes_property_deferred_change___lambda12__gsource_func, g_object_ref (self), g_object_unref);
#line 28 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->deferred_change_id = _tmp5_;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value = NULL;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value_target = NULL;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value_target_destroy_notify = NULL;
#line 486 "i-properties-provider.c"
}


static void boxes_property_class_init (BoxesPropertyClass * klass) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_property_parent_class = g_type_class_peek_parent (klass);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_type_class_add_private (klass, sizeof (BoxesPropertyPrivate));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_property_get_property;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_boxes_property_set_property;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (klass)->finalize = boxes_property_finalize;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_WIDGET, g_param_spec_object ("widget", "widget", "widget", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_REBOOT_REQUIRED, g_param_spec_boolean ("reboot-required", "reboot-required", "reboot-required", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_DEFER_INTERVAL, g_param_spec_uint ("defer-interval", "defer-interval", "defer-interval", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 509 "i-properties-provider.c"
}


static void boxes_property_instance_init (BoxesProperty * self) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv = BOXES_PROPERTY_GET_PRIVATE (self);
#line 9 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_defer_interval = (guint) 1;
#line 518 "i-properties-provider.c"
}


static void boxes_property_finalize (GObject* obj) {
	BoxesProperty * self;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_PROPERTY, BoxesProperty);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (self->priv->_description);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_object_unref0 (self->priv->_widget);
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	(self->priv->_deferred_change_target_destroy_notify == NULL) ? NULL : (self->priv->_deferred_change_target_destroy_notify (self->priv->_deferred_change_target), NULL);
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change = NULL;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target = NULL;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target_destroy_notify = NULL;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (boxes_property_parent_class)->finalize (obj);
#line 540 "i-properties-provider.c"
}


GType boxes_property_get_type (void) {
	static volatile gsize boxes_property_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_property_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesPropertyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_property_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesProperty), 0, (GInstanceInitFunc) boxes_property_instance_init, NULL };
		GType boxes_property_type_id;
		boxes_property_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesProperty", &g_define_type_info, 0);
		g_once_init_leave (&boxes_property_type_id__volatile, boxes_property_type_id);
	}
	return boxes_property_type_id__volatile;
}


static void _vala_boxes_property_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	BoxesProperty * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_PROPERTY, BoxesProperty);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	switch (property_id) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DESCRIPTION:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_string (value, boxes_property_get_description (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_WIDGET:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_object (value, boxes_property_get_widget (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_REBOOT_REQUIRED:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_boolean (value, boxes_property_get_reboot_required (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DEFER_INTERVAL:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_uint (value, boxes_property_get_defer_interval (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 585 "i-properties-provider.c"
		default:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 591 "i-properties-provider.c"
	}
}


static void _vala_boxes_property_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	BoxesProperty * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_PROPERTY, BoxesProperty);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	switch (property_id) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DESCRIPTION:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_description (self, g_value_get_string (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_WIDGET:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_widget (self, g_value_get_object (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_REBOOT_REQUIRED:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_reboot_required (self, g_value_get_boolean (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DEFER_INTERVAL:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_defer_interval (self, g_value_get_uint (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 625 "i-properties-provider.c"
		default:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 631 "i-properties-provider.c"
	}
}


GList* boxes_iproperties_provider_get_properties (BoxesIPropertiesProvider* self, BoxesPropertiesPage page) {
#line 54 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE (self)->get_properties (self, page);
#line 641 "i-properties-provider.c"
}


BoxesProperty* boxes_iproperties_provider_add_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, GtkWidget* widget) {
	BoxesProperty* result = NULL;
	const gchar* _tmp0_;
	GtkWidget* _tmp1_;
	BoxesProperty* _tmp2_;
	BoxesProperty* property;
	BoxesProperty* _tmp3_;
#line 56 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 56 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 57 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = name;
#line 57 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = widget;
#line 57 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = boxes_property_new (_tmp0_, _tmp1_);
#line 57 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	property = _tmp2_;
#line 58 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = _g_object_ref0 (property);
#line 58 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	*list = g_list_append (*list, _tmp3_);
#line 59 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = property;
#line 59 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 672 "i-properties-provider.c"
}


static Block11Data* block11_data_ref (Block11Data* _data11_) {
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return _data11_;
#line 681 "i-properties-provider.c"
}


static void block11_data_unref (void * _userdata_) {
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 690 "i-properties-provider.c"
		BoxesIPropertiesProvider * self;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		self = _data11_->self;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data11_->property);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data11_->entry);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (self);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_slice_free (Block11Data, _data11_);
#line 702 "i-properties-provider.c"
	}
}


static void __lambda19_ (Block11Data* _data11_) {
	BoxesIPropertiesProvider * self;
	GError * _inner_error_ = NULL;
#line 73 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = _data11_->self;
#line 712 "i-properties-provider.c"
	{
		PropertyStringChanged _tmp0_;
		void* _tmp0__target;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ = _data11_->changed;
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0__target = _data11_->changed_target;
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp1_ = boxes_editable_entry_get_text (_data11_->entry);
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp2_ = _tmp1_;
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ (_data11_->property, _tmp2_, _tmp0__target, &_inner_error_);
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		if (_inner_error_ != NULL) {
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			if (g_error_matches (_inner_error_, BOXES_ERROR, BOXES_ERROR_INVALID)) {
#line 732 "i-properties-provider.c"
				goto __catch10_boxes_error_invalid;
			}
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			if (_inner_error_->domain == BOXES_ERROR) {
#line 737 "i-properties-provider.c"
				goto __catch10_boxes_error;
			}
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_clear_error (&_inner_error_);
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			return;
#line 746 "i-properties-provider.c"
		}
	}
	goto __finally10;
	__catch10_boxes_error_invalid:
	{
		GError* _error_ = NULL;
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_error_ = _inner_error_;
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_inner_error_ = NULL;
#line 77 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_editable_entry_start_editing (_data11_->entry);
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_error_free0 (_error_);
#line 761 "i-properties-provider.c"
	}
	goto __finally10;
	__catch10_boxes_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_error_ = _inner_error_;
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_inner_error_ = NULL;
#line 79 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp3_ = _error_;
#line 79 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp4_ = _tmp3_->message;
#line 79 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_warning ("i-properties-provider.vala:79: %s", _tmp4_);
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_error_free0 (_error_);
#line 781 "i-properties-provider.c"
	}
	__finally10:
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_inner_error_ != NULL) {
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_clear_error (&_inner_error_);
#line 74 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 792 "i-properties-provider.c"
	}
}


static void ___lambda19__boxes_editable_entry_editing_done (BoxesEditableEntry* _sender, gpointer self) {
#line 73 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	__lambda19_ (self);
#line 800 "i-properties-provider.c"
}


BoxesProperty* boxes_iproperties_provider_add_string_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, const gchar* value, PropertyStringChanged changed, void* changed_target) {
	BoxesProperty* result = NULL;
	Block11Data* _data11_;
	PropertyStringChanged _tmp0_;
	void* _tmp0__target;
	BoxesEditableEntry* _tmp1_;
	const gchar* _tmp2_;
	PropertyStringChanged _tmp3_;
	void* _tmp3__target;
	const gchar* _tmp4_;
	BoxesProperty* _tmp5_ = NULL;
	BoxesProperty* _tmp6_;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_->_ref_count_ = 1;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_->self = g_object_ref (self);
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = changed;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0__target = changed_target;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_->changed = _tmp0_;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_->changed_target = _tmp0__target;
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = boxes_editable_entry_new ();
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_ref_sink (_tmp1_);
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_->entry = _tmp1_;
#line 68 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = value;
#line 68 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_editable_entry_set_text (_data11_->entry, _tmp2_);
#line 69 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_editable_entry_set_selectable (_data11_->entry, TRUE);
#line 70 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = _data11_->changed;
#line 70 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3__target = _data11_->changed_target;
#line 70 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_editable_entry_set_editable (_data11_->entry, _tmp3_ != NULL);
#line 72 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = name;
#line 72 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp5_ = boxes_iproperties_provider_add_property (self, list, _tmp4_, (GtkWidget*) _data11_->entry);
#line 72 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_->property = _tmp5_;
#line 73 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_signal_connect_data (_data11_->entry, "editing-done", (GCallback) ___lambda19__boxes_editable_entry_editing_done, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp6_ = _g_object_ref0 (_data11_->property);
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp6_;
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	block11_data_unref (_data11_);
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data11_ = NULL;
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 870 "i-properties-provider.c"
}


static Block12Data* block12_data_ref (Block12Data* _data12_) {
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return _data12_;
#line 879 "i-properties-provider.c"
}


static void block12_data_unref (void * _userdata_) {
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 888 "i-properties-provider.c"
		BoxesIPropertiesProvider * self;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		self = _data12_->self;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data12_->property);
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data12_->scale);
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (self);
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_slice_free (Block12Data, _data12_);
#line 900 "i-properties-provider.c"
	}
}


static gchar* __lambda20_ (BoxesIPropertiesProvider* self, GtkScale* scale, gdouble value) {
	gchar* result = NULL;
	gdouble _tmp0_;
	gchar* _tmp1_ = NULL;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (scale != NULL, NULL);
#line 96 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 96 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = g_format_size_full (((guint64) _tmp0_) * OSINFO_KIBIBYTES, G_FORMAT_SIZE_IEC_UNITS);
#line 96 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp1_;
#line 96 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 919 "i-properties-provider.c"
}


static gchar* ___lambda20__gtk_scale_format_value (GtkScale* _sender, gdouble value, gpointer self) {
	gchar* result;
	result = __lambda20_ (self, _sender, value);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 928 "i-properties-provider.c"
}


static void ___lambda21_ (Block12Data* _data12_) {
	BoxesIPropertiesProvider * self;
	GError * _inner_error_ = NULL;
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = _data12_->self;
#line 937 "i-properties-provider.c"
	{
		PropertySizeChanged _tmp0_;
		void* _tmp0__target;
		BoxesProperty* _tmp1_;
		GtkHScale* _tmp2_;
		gdouble _tmp3_ = 0.0;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ = _data12_->changed;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0__target = _data12_->changed_target;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp1_ = _data12_->property;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp2_ = _data12_->scale;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp3_ = gtk_range_get_value ((GtkRange*) _tmp2_);
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ (_tmp1_, (guint64) _tmp3_, _tmp0__target, &_inner_error_);
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		if (_inner_error_ != NULL) {
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			if (_inner_error_->domain == BOXES_ERROR) {
#line 960 "i-properties-provider.c"
				goto __catch11_boxes_error;
			}
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_clear_error (&_inner_error_);
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			return;
#line 969 "i-properties-provider.c"
		}
	}
	goto __finally11;
	__catch11_boxes_error:
	{
		GError* _error_ = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 106 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_error_ = _inner_error_;
#line 106 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_inner_error_ = NULL;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp4_ = _error_;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp5_ = _tmp4_->message;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_warning ("i-properties-provider.vala:109: %s", _tmp5_);
#line 106 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_error_free0 (_error_);
#line 990 "i-properties-provider.c"
	}
	__finally11:
#line 106 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_inner_error_ != NULL) {
#line 106 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 106 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_clear_error (&_inner_error_);
#line 106 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 1001 "i-properties-provider.c"
	}
}


static void ____lambda21__gtk_range_value_changed (GtkRange* _sender, gpointer self) {
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	___lambda21_ (self);
#line 1009 "i-properties-provider.c"
}


BoxesProperty* boxes_iproperties_provider_add_size_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, guint64 size, guint64 min, guint64 max, guint64 step, PropertySizeChanged changed, void* changed_target) {
	BoxesProperty* result = NULL;
	Block12Data* _data12_;
	PropertySizeChanged _tmp0_;
	void* _tmp0__target;
	guint64 _tmp1_;
	guint64 _tmp2_;
	guint64 _tmp3_;
	GtkHScale* _tmp4_;
	GtkHScale* _tmp5_;
	GtkHScale* _tmp6_;
	guint64 _tmp7_;
	GtkHScale* _tmp8_;
	GtkHScale* _tmp9_;
	const gchar* _tmp10_;
	GtkHScale* _tmp11_;
	BoxesProperty* _tmp12_ = NULL;
	PropertySizeChanged _tmp13_;
	void* _tmp13__target;
	BoxesProperty* _tmp15_;
	BoxesProperty* _tmp16_;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_->_ref_count_ = 1;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_->self = g_object_ref (self);
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = changed;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0__target = changed_target;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_->changed = _tmp0_;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_->changed_target = _tmp0__target;
#line 93 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = min;
#line 93 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = max;
#line 93 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = step;
#line 93 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = (GtkHScale*) gtk_hscale_new_with_range ((gdouble) _tmp1_, (gdouble) _tmp2_, (gdouble) _tmp3_);
#line 93 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_ref_sink (_tmp4_);
#line 93 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_->scale = _tmp4_;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp5_ = _data12_->scale;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_signal_connect_object ((GtkScale*) _tmp5_, "format-value", (GCallback) ___lambda20__gtk_scale_format_value, self, 0);
#line 99 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp6_ = _data12_->scale;
#line 99 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp7_ = size;
#line 99 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_range_set_value ((GtkRange*) _tmp6_, (gdouble) _tmp7_);
#line 100 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp8_ = _data12_->scale;
#line 100 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
#line 101 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp9_ = _data12_->scale;
#line 101 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp9_, 20);
#line 103 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp10_ = name;
#line 103 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp11_ = _data12_->scale;
#line 103 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp12_ = boxes_iproperties_provider_add_property (self, list, _tmp10_, (GtkWidget*) _tmp11_);
#line 103 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_->property = _tmp12_;
#line 104 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp13_ = _data12_->changed;
#line 104 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp13__target = _data12_->changed_target;
#line 104 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp13_ != NULL) {
#line 1094 "i-properties-provider.c"
		GtkHScale* _tmp14_;
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp14_ = _data12_->scale;
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_signal_connect_data ((GtkRange*) _tmp14_, "value-changed", (GCallback) ____lambda21__gtk_range_value_changed, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 1100 "i-properties-provider.c"
	}
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp15_ = _data12_->property;
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp16_;
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	block12_data_unref (_data12_);
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data12_ = NULL;
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 1114 "i-properties-provider.c"
}


static void boxes_iproperties_provider_base_init (BoxesIPropertiesProviderIface * iface) {
#line 53 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	static gboolean initialized = FALSE;
#line 53 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (!initialized) {
#line 53 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		initialized = TRUE;
#line 1125 "i-properties-provider.c"
	}
}


GType boxes_iproperties_provider_get_type (void) {
	static volatile gsize boxes_iproperties_provider_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_iproperties_provider_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesIPropertiesProviderIface), (GBaseInitFunc) boxes_iproperties_provider_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType boxes_iproperties_provider_type_id;
		boxes_iproperties_provider_type_id = g_type_register_static (G_TYPE_INTERFACE, "BoxesIPropertiesProvider", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (boxes_iproperties_provider_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&boxes_iproperties_provider_type_id__volatile, boxes_iproperties_provider_type_id);
	}
	return boxes_iproperties_provider_type_id__volatile;
}



